<template>
    <div class="details-header">
        <details-header-item v-for="(obj, key) in config" :key="key" :id="key" :config="obj" :value="itemValue(key, obj)"/>
    </div>
</template>

<script>
import DetailsHeaderItem from './DetailsHeaderItem';

export default {
    name: 'DetailsHeaderList',
    components: {
        DetailsHeaderItem,
    },
    props: {
        config: { // design config
            type: Object,
            required: false,
        },
        data: { // user data from server
            type: Object,
            required: false,
        },
    },
    computed: {
        itemValue: vm => (key, conf) => {
            // for complex parameter: collect data from several params in one object
            if (conf.complex && typeof vm.data[key] !== 'object') {
                const dataObj = {};
                const { url, content } = conf.complex;
                dataObj[key] = vm.data[key];
                if (url) {
                    dataObj[url] = vm.data[url];
                }
                if (content) {
                    if (typeof content === 'string') {
                        dataObj[content] = vm.data[content];
                    } else {
                        Object.keys(content).forEach((contentKey) => {
                            dataObj[contentKey] = contentKey.includes('custom_title') ? content[contentKey] : vm.data[contentKey];
                        });
                    }
                }
                return dataObj;
            }
            return vm.data[key];
        },
    },
};
</script>
